import { LRLanguage, indentNodeProp, delimitedIndent, LanguageSupport } from '@codemirror/language';
import { javascriptLanguage, javascript } from '@codemirror/lang-javascript';
import { styleTags, tags } from '@lezer/highlight';
import { parseMixed } from '@lezer/common';
import { ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const JavascriptExpression = 1,
  Text = 2;

const percent = 37;
const closeAngle = 62;
const dash = 45;
const underscore = 95;
const openAngle = 60;
const singleQuote = 39;
const doubleQuote = 34;
const javascriptExpressionOrText = new ExternalTokenizer((input, stack) => {
    let { next } = input;
    while (next !== -1) {
        if (((next === singleQuote || next === doubleQuote) &&
            input.peek(1) === openAngle &&
            input.peek(2) === percent) ||
            (next === openAngle && input.peek(1) === percent)) {
            break;
        }
        if (next === percent &&
            (([dash, underscore].indexOf(input.peek(1)) > -1 &&
                input.peek(2) === closeAngle) ||
                input.peek(1) === closeAngle)) {
            break;
        }
        next = input.advance();
    }
    if (stack.canShift(JavascriptExpression)) {
        input.acceptToken(JavascriptExpression);
    }
    else if (stack.canShift(Text)) {
        input.acceptToken(Text);
    }
}, { contextual: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$OOYQROOPkOPOOOpQRO'#CbOuQRO'#CeOOQO'#Cq'#CqOOQO'#Cp'#CpOzQPO'#CpOzQPO'#CpQOQPOOP!SOSO'#C_POOO)C>a)C>aO!_QPO,58|O!dQPO,59PO!iQPO,59[O!nQPO,59[POOO'#Ci'#CiP!sOSO,58yPOOO,58y,58yOOQO1G.h1G.hOOQO1G.k1G.kOOQO1G.v1G.vPOOO-E6g-E6gPOOO1G.e1G.e",
  stateData: "#R~O`OSaPQ~OQTOVQOYROZUO[VO~OaXO~OPZO~OP[O~OVQOYRO~OS_Ob_OcaO~OWbO~OWcO~OZdO~O[dO~OS_Ob_OcfO~OYV~",
  goto: "!RfPPPgPPjPPjPPPoPPPPPPuxRYPVSOUVQ`XRe`RWOQTOQ]UR^V",
  nodeNames: "⚠ JavascriptExpression Text Comment CommentContent Program Scriptlet OpeningTag ClosingTag Output OutputTag Quote Quote",
  maxTerm: 21,
  nodeProps: [
    ["closedBy", 7,"ClosingTag"],
    ["openedBy", 8,"OpeningTag"]
  ],
  skippedNodes: [0,3,4,13],
  repeatNodeCount: 1,
  tokenData: "$j~R`X^!Tpq!Trs!xuv!}wx#b}!O#g!^!_#m#R#S#g#y#z!T$f$g!T#BY#BZ!T$IS$I_!T$I|$JO!T$JT$JU!T$KV$KW!T&FU&FV!T~!YY`~X^!Tpq!T#y#z!T$f$g!T#BY#BZ!T$IS$I_!T$I|$JO!T$JT$JU!T$KV$KW!T&FU&FV!T~!}O[~~#QP!`!a#T~#YPW~~~#]~#bOW~~#gOZ~~#jPuv!}~#pPuv#s~#xTV~st$Xuv$^}!O$^!_!`$c#R#S$^~$^Oa~~$cOV~~$jOY~V~",
  tokenizers: [1, javascriptExpressionOrText, new LocalTokenGroup("!O~RSYZ_uvd}!Ow#R#Sw~dOb~~gP!`!aj~oPc~~~r~wOc~~zPuvd~", 45, 4)],
  topRules: {"Program":[0,5]},
  tokenPrec: 92
});

const ejsLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                JavascriptExpression: delimitedIndent({ closing: "%>", align: false }),
            }),
            styleTags({
                "OutputTag OpeningTag ClosingTag": tags.controlOperator,
                CommentContent: tags.comment,
                Quote: tags.quote,
            }),
        ],
        wrap: parseMixed((node) => node.type.isTop
            ? {
                parser: javascriptLanguage.parser,
                overlay: (node) => node.type.name === "JavascriptExpression",
            }
            : null),
    }),
});
function ejs() {
    return new LanguageSupport(ejsLanguage, javascript().support);
}

export { ejs, ejsLanguage };
